Index: branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 367)
+++ branches/v5/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 440)
@@ -6898,138 +7612,62 @@
   } // end switch alloc_heap_fsm
 
-
-  ////////////////////////////////////////////////////////////////////////////////////
+  /////////////////////////////////////////////////////////////////////
   //    TGT_CMD to READ FIFO
-  ////////////////////////////////////////////////////////////////////////////////////
-
-  if(cmd_read_fifo_put)
-  {
-    if(cmd_read_fifo_get)
-    {
-      m_cmd_read_addr_fifo.put_and_get((addr_t)(p_vci_tgt.address.read()));
-      m_cmd_read_length_fifo.put_and_get(p_vci_tgt.plen.read() >>2);
-      m_cmd_read_srcid_fifo.put_and_get(p_vci_tgt.srcid.read());
-      m_cmd_read_trdid_fifo.put_and_get(p_vci_tgt.trdid.read());
-      m_cmd_read_pktid_fifo.put_and_get(p_vci_tgt.pktid.read());
-    }
-    else
-    {
-      m_cmd_read_addr_fifo.simple_put((addr_t)(p_vci_tgt.address.read()));
-      m_cmd_read_length_fifo.simple_put(p_vci_tgt.plen.read() >>2);
-      m_cmd_read_srcid_fifo.simple_put(p_vci_tgt.srcid.read());
-      m_cmd_read_trdid_fifo.simple_put(p_vci_tgt.trdid.read());
-      m_cmd_read_pktid_fifo.simple_put(p_vci_tgt.pktid.read());
-    }
-  }
-  else
-  {
-    if(cmd_read_fifo_get)
-    {
-      m_cmd_read_addr_fifo.simple_get();
-      m_cmd_read_length_fifo.simple_get();
-      m_cmd_read_srcid_fifo.simple_get();
-      m_cmd_read_trdid_fifo.simple_get();
-      m_cmd_read_pktid_fifo.simple_get();
-    }
-  }
+  /////////////////////////////////////////////////////////////////////
+
+  m_cmd_read_addr_fifo.update(   cmd_read_fifo_get, cmd_read_fifo_put, 
+                                 p_vci_tgt.address.read() );
+  m_cmd_read_length_fifo.update( cmd_read_fifo_get, cmd_read_fifo_put, 
+                                 p_vci_tgt.plen.read()>>2 );
+  m_cmd_read_srcid_fifo.update(  cmd_read_fifo_get, cmd_read_fifo_put, 
+                                 p_vci_tgt.srcid.read() );
+  m_cmd_read_trdid_fifo.update(  cmd_read_fifo_get, cmd_read_fifo_put, 
+                                 p_vci_tgt.trdid.read() );
+  m_cmd_read_pktid_fifo.update(  cmd_read_fifo_get, cmd_read_fifo_put, 
+                                 p_vci_tgt.pktid.read() );
+
   /////////////////////////////////////////////////////////////////////
   //    TGT_CMD to WRITE FIFO
   /////////////////////////////////////////////////////////////////////
 
-  if(cmd_write_fifo_put)
-  {
-    if(cmd_write_fifo_get)
-    {
-      m_cmd_write_addr_fifo.put_and_get((addr_t)(p_vci_tgt.address.read()));
-      m_cmd_write_eop_fifo.put_and_get(p_vci_tgt.eop.read());
-      m_cmd_write_srcid_fifo.put_and_get(p_vci_tgt.srcid.read());
-      m_cmd_write_trdid_fifo.put_and_get(p_vci_tgt.trdid.read());
-      m_cmd_write_pktid_fifo.put_and_get(p_vci_tgt.pktid.read());
-      m_cmd_write_data_fifo.put_and_get(p_vci_tgt.wdata.read());
-      m_cmd_write_be_fifo.put_and_get(p_vci_tgt.be.read());
-    }
-    else
-    {
-      m_cmd_write_addr_fifo.simple_put((addr_t)(p_vci_tgt.address.read()));
-      m_cmd_write_eop_fifo.simple_put(p_vci_tgt.eop.read());
-      m_cmd_write_srcid_fifo.simple_put(p_vci_tgt.srcid.read());
-      m_cmd_write_trdid_fifo.simple_put(p_vci_tgt.trdid.read());
-      m_cmd_write_pktid_fifo.simple_put(p_vci_tgt.pktid.read());
-      m_cmd_write_data_fifo.simple_put(p_vci_tgt.wdata.read());
-      m_cmd_write_be_fifo.simple_put(p_vci_tgt.be.read());
-    }
-  }
-  else
-  {
-    if(cmd_write_fifo_get)
-    {
-      m_cmd_write_addr_fifo.simple_get();
-      m_cmd_write_eop_fifo.simple_get();
-      m_cmd_write_srcid_fifo.simple_get();
-      m_cmd_write_trdid_fifo.simple_get();
-      m_cmd_write_pktid_fifo.simple_get();
-      m_cmd_write_data_fifo.simple_get();
-      m_cmd_write_be_fifo.simple_get();
-    }
-  }
+  m_cmd_write_addr_fifo.update(  cmd_write_fifo_get, cmd_write_fifo_put,
+                                 (addr_t)p_vci_tgt.address.read() );
+  m_cmd_write_eop_fifo.update(   cmd_write_fifo_get, cmd_write_fifo_put,
+                                 p_vci_tgt.eop.read() );
+  m_cmd_write_srcid_fifo.update( cmd_write_fifo_get, cmd_write_fifo_put,
+                                 p_vci_tgt.srcid.read() );
+  m_cmd_write_trdid_fifo.update( cmd_write_fifo_get, cmd_write_fifo_put,
+                                 p_vci_tgt.trdid.read() );
+  m_cmd_write_pktid_fifo.update( cmd_write_fifo_get, cmd_write_fifo_put,
+                                 p_vci_tgt.pktid.read() );
+  m_cmd_write_data_fifo.update(  cmd_write_fifo_get, cmd_write_fifo_put,
+                                 p_vci_tgt.wdata.read() );
+  m_cmd_write_be_fifo.update(    cmd_write_fifo_get, cmd_write_fifo_put,
+                                 p_vci_tgt.be.read() );
+
   ////////////////////////////////////////////////////////////////////////////////////
   //    TGT_CMD to CAS FIFO
   ////////////////////////////////////////////////////////////////////////////////////
 
-  if(cmd_cas_fifo_put)
-  {
-    if(cmd_cas_fifo_get)
-    {
-      m_cmd_cas_addr_fifo.put_and_get((addr_t)(p_vci_tgt.address.read()));
-      m_cmd_cas_eop_fifo.put_and_get(p_vci_tgt.eop.read());
-      m_cmd_cas_srcid_fifo.put_and_get(p_vci_tgt.srcid.read());
-      m_cmd_cas_trdid_fifo.put_and_get(p_vci_tgt.trdid.read());
-      m_cmd_cas_pktid_fifo.put_and_get(p_vci_tgt.pktid.read());
-      m_cmd_cas_wdata_fifo.put_and_get(p_vci_tgt.wdata.read());
-    }
-    else
-    {
-      m_cmd_cas_addr_fifo.simple_put((addr_t)(p_vci_tgt.address.read()));
-      m_cmd_cas_eop_fifo.simple_put(p_vci_tgt.eop.read());
-      m_cmd_cas_srcid_fifo.simple_put(p_vci_tgt.srcid.read());
-      m_cmd_cas_trdid_fifo.simple_put(p_vci_tgt.trdid.read());
-      m_cmd_cas_pktid_fifo.simple_put(p_vci_tgt.pktid.read());
-      m_cmd_cas_wdata_fifo.simple_put(p_vci_tgt.wdata.read());
-    }
-  }
-  else
-  {
-    if(cmd_cas_fifo_get)
-    {
-      m_cmd_cas_addr_fifo.simple_get();
-      m_cmd_cas_eop_fifo.simple_get();
-      m_cmd_cas_srcid_fifo.simple_get();
-      m_cmd_cas_trdid_fifo.simple_get();
-      m_cmd_cas_pktid_fifo.simple_get();
-      m_cmd_cas_wdata_fifo.simple_get();
-    }
-  }
+  m_cmd_cas_addr_fifo.update(  cmd_cas_fifo_get, cmd_cas_fifo_put,
+                               (addr_t)p_vci_tgt.address.read() );
+  m_cmd_cas_eop_fifo.update(   cmd_cas_fifo_get, cmd_cas_fifo_put,
+                               p_vci_tgt.eop.read() );
+  m_cmd_cas_srcid_fifo.update( cmd_cas_fifo_get, cmd_cas_fifo_put,
+                               p_vci_tgt.srcid.read() );
+  m_cmd_cas_trdid_fifo.update( cmd_cas_fifo_get, cmd_cas_fifo_put,
+                               p_vci_tgt.trdid.read() );
+  m_cmd_cas_pktid_fifo.update( cmd_cas_fifo_get, cmd_cas_fifo_put,
+                               p_vci_tgt.pktid.read() );
+  m_cmd_cas_wdata_fifo.update( cmd_cas_fifo_get, cmd_cas_fifo_put,
+                               p_vci_tgt.wdata.read() );
+
   ////////////////////////////////////////////////////////////////////////////////////
   //    CC_RECEIVE to CLEANUP FIFO
   ////////////////////////////////////////////////////////////////////////////////////
 
-  if(cc_receive_to_cleanup_fifo_put)
-  {
-    if(cc_receive_to_cleanup_fifo_get)
-    {
-      m_cc_receive_to_cleanup_fifo.put_and_get(p_dspin_in.data.read());
-    }
-    else
-    {
-      m_cc_receive_to_cleanup_fifo.simple_put(p_dspin_in.data.read());
-    }
-  }
-  else
-  {
-    if(cc_receive_to_cleanup_fifo_get)
-    {
-      m_cc_receive_to_cleanup_fifo.simple_get();
-    }
-  }
+  m_cc_receive_to_cleanup_fifo.update( cc_receive_to_cleanup_fifo_get,
+                                       cc_receive_to_cleanup_fifo_put, 
+                                       p_dspin_in.data.read() );
 
   ////////////////////////////////////////////////////////////////////////////////////
@@ -7037,22 +7675,7 @@
   ////////////////////////////////////////////////////////////////////////////////////
 
-  if(cc_receive_to_multi_ack_fifo_put)
-  {
-    if(cc_receive_to_multi_ack_fifo_get)
-    {
-      m_cc_receive_to_multi_ack_fifo.put_and_get(p_dspin_in.data.read());
-    }
-    else
-    {
-      m_cc_receive_to_multi_ack_fifo.simple_put(p_dspin_in.data.read());
-    }
-  }
-  else
-  {
-    if(cc_receive_to_multi_ack_fifo_get)
-    {
-      m_cc_receive_to_multi_ack_fifo.simple_get();
-    }
-  }
+  m_cc_receive_to_multi_ack_fifo.update( cc_receive_to_multi_ack_fifo_get,
+                                         cc_receive_to_multi_ack_fifo_put, 
+                                         p_dspin_in.data.read() );
 
   ////////////////////////////////////////////////////////////////////////////////////
@@ -7060,102 +7683,51 @@
   ////////////////////////////////////////////////////////////////////////////////////
 
-  if(write_to_cc_send_fifo_put)
-  {
-    if(write_to_cc_send_fifo_get)
-    {
-      m_write_to_cc_send_inst_fifo.put_and_get(write_to_cc_send_fifo_inst);
-      m_write_to_cc_send_srcid_fifo.put_and_get(write_to_cc_send_fifo_srcid);
+  m_write_to_cc_send_inst_fifo.update( write_to_cc_send_fifo_get, write_to_cc_send_fifo_put,
+                                       write_to_cc_send_fifo_inst );
+  m_write_to_cc_send_srcid_fifo.update( write_to_cc_send_fifo_get, write_to_cc_send_fifo_put,
+                                        write_to_cc_send_fifo_srcid );
 #if L1_MULTI_CACHE
-      m_write_to_cc_send_cache_id_fifo.put_and_get(write_to_cc_send_fifo_cache_id);
-#endif
-    }
-    else
-    {
-      m_write_to_cc_send_inst_fifo.simple_put(write_to_cc_send_fifo_inst);
-      m_write_to_cc_send_srcid_fifo.simple_put(write_to_cc_send_fifo_srcid);
+  m_write_to_cc_send_cache_id_fifo.update( write_to_cc_send_fifo_get, write_to_cc_send_fifo_put,
+                                           write_to_cc_send_fifo_cache_id );
+#endif
+
+  ////////////////////////////////////////////////////////////////////////////////////
+  //    CONFIG to CC_SEND FIFO
+  ////////////////////////////////////////////////////////////////////////////////////
+
+  m_config_to_cc_send_inst_fifo.update( config_to_cc_send_fifo_get, config_to_cc_send_fifo_put,
+                                        config_to_cc_send_fifo_inst );
+  m_config_to_cc_send_srcid_fifo.update( config_to_cc_send_fifo_get, config_to_cc_send_fifo_put,
+                                         config_to_cc_send_fifo_srcid );
 #if L1_MULTI_CACHE
-      m_write_to_cc_send_cache_id_fifo.simple_put(write_to_cc_send_fifo_cache_id);
-#endif
-    }
-  }
-  else
-  {
-    if(write_to_cc_send_fifo_get)
-    {
-      m_write_to_cc_send_inst_fifo.simple_get();
-      m_write_to_cc_send_srcid_fifo.simple_get();
-#if L1_MULTI_CACHE
-      m_write_to_cc_send_cache_id_fifo.simple_get();
-#endif
-    }
-  }
+  m_config_to_cc_send_cache_id_fifo.update( config_to_cc_send_fifo_get, config_to_cc_send_fifo_put,
+                                            config_to_cc_send_fifo_cache_id );
+#endif
+
   ////////////////////////////////////////////////////////////////////////////////////
   //    XRAM_RSP to CC_SEND FIFO
   ////////////////////////////////////////////////////////////////////////////////////
 
-  if(xram_rsp_to_cc_send_fifo_put)
-  {
-    if(xram_rsp_to_cc_send_fifo_get)
-    {
-      m_xram_rsp_to_cc_send_inst_fifo.put_and_get(xram_rsp_to_cc_send_fifo_inst);
-      m_xram_rsp_to_cc_send_srcid_fifo.put_and_get(xram_rsp_to_cc_send_fifo_srcid);
+  m_xram_rsp_to_cc_send_inst_fifo.update( xram_rsp_to_cc_send_fifo_get, xram_rsp_to_cc_send_fifo_put,
+                                          xram_rsp_to_cc_send_fifo_inst );
+  m_xram_rsp_to_cc_send_srcid_fifo.update( xram_rsp_to_cc_send_fifo_get, xram_rsp_to_cc_send_fifo_put,
+                                           xram_rsp_to_cc_send_fifo_srcid );
 #if L1_MULTI_CACHE
-      m_xram_rsp_to_cc_send_cache_id_fifo.put_and_get(xram_rsp_to_cc_send_fifo_cache_id);
-#endif
-    }
-    else
-    {
-      m_xram_rsp_to_cc_send_inst_fifo.simple_put(xram_rsp_to_cc_send_fifo_inst);
-      m_xram_rsp_to_cc_send_srcid_fifo.simple_put(xram_rsp_to_cc_send_fifo_srcid);
-#if L1_MULTI_CACHE
-      m_xram_rsp_to_cc_send_cache_id_fifo.simple_put(xram_rsp_to_cc_send_fifo_cache_id);
-#endif
-    }
-  }
-  else
-  {
-    if(xram_rsp_to_cc_send_fifo_get)
-    {
-      m_xram_rsp_to_cc_send_inst_fifo.simple_get();
-      m_xram_rsp_to_cc_send_srcid_fifo.simple_get();
-#if L1_MULTI_CACHE
-      m_xram_rsp_to_cc_send_cache_id_fifo.simple_get();
-#endif
-    }
-  }
+  m_xram_rsp_to_cc_send_cache_id_fifo.update( xram_rsp_to_cc_send_fifo_get, xram_rsp_to_cc_send_fifo_put,
+                                              xram_rsp_to_cc_send_fifo_cache_id );
+#endif
+
   ////////////////////////////////////////////////////////////////////////////////////
   //    CAS to CC_SEND FIFO
   ////////////////////////////////////////////////////////////////////////////////////
 
-  if(cas_to_cc_send_fifo_put)
-  {
-    if(cas_to_cc_send_fifo_get)
-    {
-      m_cas_to_cc_send_inst_fifo.put_and_get(cas_to_cc_send_fifo_inst);
-      m_cas_to_cc_send_srcid_fifo.put_and_get(cas_to_cc_send_fifo_srcid);
+  m_cas_to_cc_send_inst_fifo.update( cas_to_cc_send_fifo_get, cas_to_cc_send_fifo_put,
+                                     cas_to_cc_send_fifo_inst );
+  m_cas_to_cc_send_srcid_fifo.update( cas_to_cc_send_fifo_get, cas_to_cc_send_fifo_put,
+                                      cas_to_cc_send_fifo_srcid );
 #if L1_MULTI_CACHE
-      m_cas_to_cc_send_cache_id_fifo.put_and_get(cas_to_cc_send_fifo_cache_id);
-#endif
-    }
-    else
-    {
-      m_cas_to_cc_send_inst_fifo.simple_put(cas_to_cc_send_fifo_inst);
-      m_cas_to_cc_send_srcid_fifo.simple_put(cas_to_cc_send_fifo_srcid);
-#if L1_MULTI_CACHE
-      m_cas_to_cc_send_cache_id_fifo.simple_put(cas_to_cc_send_fifo_cache_id);
-#endif
-    }
-  }
-  else
-  {
-    if(cas_to_cc_send_fifo_get)
-    {
-      m_cas_to_cc_send_inst_fifo.simple_get();
-      m_cas_to_cc_send_srcid_fifo.simple_get();
-#if L1_MULTI_CACHE
-      m_cas_to_cc_send_cache_id_fifo.simple_get();
-#endif
-    }
-  }
+  m_cas_to_cc_send_cache_id_fifo.update( cas_to_cc_send_fifo_get, cas_to_cc_send_fifo_put,
+                                         cas_to_cc_send_fifo_cache_id );
+#endif
 
   m_cpt_cycles++;
@@ -7171,5 +7743,5 @@
   ////////////////////////////////////////////////////////////
 
-  p_vci_ixr.be      = 0xF;
+  p_vci_ixr.be      = 0xFF;   // nor transmited to external ram
   p_vci_ixr.pktid   = 0;
   p_vci_ixr.srcid   = m_srcid_x;
@@ -7179,79 +7751,80 @@
   p_vci_ixr.clen    = 0;
   p_vci_ixr.cfixed  = false;
-
-  if(r_ixr_cmd_fsm.read() == IXR_CMD_READ_NLINE)
+  p_vci_ixr.plen    = 64;
+
+  if(r_ixr_cmd_fsm.read() == IXR_CMD_READ)
   {
-    p_vci_ixr.cmd     = vci_param::CMD_READ;
-    p_vci_ixr.cmdval  = true;
-    p_vci_ixr.address = (addr_t)(r_read_to_ixr_cmd_nline.read() *m_words*4);
-    p_vci_ixr.plen    = m_words*4;
-    p_vci_ixr.wdata   = 0x00000000;
-    p_vci_ixr.trdid   = r_read_to_ixr_cmd_trdid.read();
-    p_vci_ixr.eop     = true;
+    p_vci_ixr.cmd       = vci_param_ext::CMD_READ;
+    p_vci_ixr.cmdval    = true;
+    p_vci_ixr.address   = (addr_t)(r_read_to_ixr_cmd_nline.read() * m_words * 4);
+    p_vci_ixr.wdata     = 0;
+    p_vci_ixr.trdid     = r_read_to_ixr_cmd_trdid.read();
+    p_vci_ixr.eop       = true;
   }
-  else if(r_ixr_cmd_fsm.read() == IXR_CMD_CAS_NLINE)
+  else if(r_ixr_cmd_fsm.read() == IXR_CMD_CAS)
   {
     if(r_cas_to_ixr_cmd_write.read())
     {
-      p_vci_ixr.cmd     = vci_param::CMD_WRITE;
+      size_t word       = r_ixr_cmd_cpt.read();
+      p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
       p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)((r_cas_to_ixr_cmd_nline.read() *m_words+r_ixr_cmd_cpt.read()) *4);
-      p_vci_ixr.plen    = m_words*4;
-      p_vci_ixr.wdata   = r_cas_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read();
+      p_vci_ixr.address = (addr_t)( (r_cas_to_ixr_cmd_nline.read() * m_words + word) * 4 );
+      p_vci_ixr.wdata   = ((wide_data_t)(r_cas_to_ixr_cmd_data[word].read()))  |
+                          ((wide_data_t)(r_cas_to_ixr_cmd_data[word+1].read()) << 32);
       p_vci_ixr.trdid   = r_cas_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words-1));
+      p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words-2));
     }
     else
     {
-      p_vci_ixr.cmd     = vci_param::CMD_READ;
+      p_vci_ixr.cmd     = vci_param_ext::CMD_READ;
       p_vci_ixr.cmdval  = true;
       p_vci_ixr.address = (addr_t)(r_cas_to_ixr_cmd_nline.read() *m_words*4);
-      p_vci_ixr.plen    = m_words*4;
-      p_vci_ixr.wdata   = 0x00000000;
+      p_vci_ixr.wdata   = 0;
       p_vci_ixr.trdid   = r_cas_to_ixr_cmd_trdid.read();
       p_vci_ixr.eop     = true;
     }
   }
-  else if(r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_NLINE)
+  else if(r_ixr_cmd_fsm.read() == IXR_CMD_WRITE)
   {
     if(r_write_to_ixr_cmd_write.read())
     {
-      p_vci_ixr.cmd     = vci_param::CMD_WRITE;
+      p_vci_ixr.cmd     = vci_param_ext::CMD_WRITE;
       p_vci_ixr.cmdval  = true;
-      p_vci_ixr.address = (addr_t)((r_write_to_ixr_cmd_nline.read() *m_words+r_ixr_cmd_cpt.read()) *4);
-      p_vci_ixr.plen    = m_words*4;
-      p_vci_ixr.wdata   = r_write_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read();
+      p_vci_ixr.address = (addr_t)( (r_write_to_ixr_cmd_nline.read() * m_words +
+                                     r_ixr_cmd_cpt.read()) * 4 );
+      p_vci_ixr.wdata   = ((wide_data_t)(r_write_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) |
+                          ((wide_data_t)(r_write_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
       p_vci_ixr.trdid   = r_write_to_ixr_cmd_trdid.read();
-      p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words-1));
+      p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words-2));
     }
     else
     {
-      p_vci_ixr.cmd     = vci_param::CMD_READ;
+      p_vci_ixr.cmd     = vci_param_ext::CMD_READ;
       p_vci_ixr.cmdval  = true;
       p_vci_ixr.address = (addr_t)(r_write_to_ixr_cmd_nline.read() *m_words*4);
-      p_vci_ixr.plen    = m_words*4;
-      p_vci_ixr.wdata   = 0x00000000;
+      p_vci_ixr.wdata   = 0;
       p_vci_ixr.trdid   = r_write_to_ixr_cmd_trdid.read();
       p_vci_ixr.eop     = true;
     }
   }
-  else if(r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_DATA)
+  else if(r_ixr_cmd_fsm.read() == IXR_CMD_XRAM)
   {
-    p_vci_ixr.cmd     = vci_param::CMD_WRITE;
-    p_vci_ixr.cmdval  = true;
-    p_vci_ixr.address = (addr_t)((r_xram_rsp_to_ixr_cmd_nline.read() *m_words+r_ixr_cmd_cpt.read()) *4);
-    p_vci_ixr.plen    = m_words*4;
-    p_vci_ixr.wdata   = r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read();
-    p_vci_ixr.trdid   = r_xram_rsp_to_ixr_cmd_trdid.read();
-    p_vci_ixr.eop     = (r_ixr_cmd_cpt == (m_words-1));
+    p_vci_ixr.cmd       = vci_param_ext::CMD_WRITE;
+    p_vci_ixr.cmdval    = true;
+    p_vci_ixr.address   = (addr_t)( (r_xram_rsp_to_ixr_cmd_nline.read() * m_words +
+                                   r_ixr_cmd_cpt.read()) * 4 );
+    p_vci_ixr.wdata     = ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()].read()) |
+                          ((wide_data_t)(r_xram_rsp_to_ixr_cmd_data[r_ixr_cmd_cpt.read()+1].read()) << 32));
+    p_vci_ixr.trdid     = r_xram_rsp_to_ixr_cmd_trdid.read();
+    p_vci_ixr.eop       = (r_ixr_cmd_cpt == (m_words-2));
   }
   else
   {
-    p_vci_ixr.cmdval  = false;
-    p_vci_ixr.address = 0;
-    p_vci_ixr.plen    = 0;
-    p_vci_ixr.wdata   = 0;
-    p_vci_ixr.trdid   = 0;
-    p_vci_ixr.eop = false;
+    p_vci_ixr.cmdval    = false;
+    p_vci_ixr.cmd       = vci_param_ext::CMD_READ;
+    p_vci_ixr.address   = 0;
+    p_vci_ixr.wdata     = 0;
+    p_vci_ixr.trdid     = 0;
+    p_vci_ixr.eop       = false;
   }
 
@@ -7260,8 +7833,8 @@
   ////////////////////////////////////////////////////
 
-  if(((r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) &&
-      (r_ixr_rsp_fsm.read()   == IXR_RSP_TRT_READ)) ||
+  if(((r_alloc_trt_fsm.read() == ALLOC_TRT_IXR_RSP) and
+      (r_ixr_rsp_fsm.read()   == IXR_RSP_TRT_READ)) or
       (r_ixr_rsp_fsm.read()   == IXR_RSP_ACK))
-    
+
     p_vci_ixr.rspack = true;
 
@@ -7276,21 +7849,22 @@
   {
     case TGT_CMD_IDLE:
-      p_vci_tgt.cmdack  = false;
+      p_vci_tgt.cmdack = false;
+      break;
+
+    case TGT_CMD_CONFIG:
+    case TGT_CMD_ERROR:
+      p_vci_tgt.cmdack = not r_tgt_cmd_to_tgt_rsp_req.read();
       break;
 
     case TGT_CMD_READ:
-      p_vci_tgt.cmdack  = m_cmd_read_addr_fifo.wok();
+      p_vci_tgt.cmdack = m_cmd_read_addr_fifo.wok();
       break;
 
     case TGT_CMD_WRITE:
-      p_vci_tgt.cmdack  = m_cmd_write_addr_fifo.wok();
+      p_vci_tgt.cmdack = m_cmd_write_addr_fifo.wok();
       break;
 
     case TGT_CMD_CAS:
-      p_vci_tgt.cmdack  = m_cmd_cas_addr_fifo.wok();
-      break;
-
-    default:
-      p_vci_tgt.cmdack  = false;
+      p_vci_tgt.cmdack = m_cmd_cas_addr_fifo.wok();
       break;
   }
@@ -7302,10 +7876,13 @@
   switch(r_tgt_rsp_fsm.read())
   {
+    case TGT_RSP_CONFIG_IDLE:
+    case TGT_RSP_TGT_CMD_IDLE:
     case TGT_RSP_READ_IDLE:
     case TGT_RSP_WRITE_IDLE:
     case TGT_RSP_CAS_IDLE:
     case TGT_RSP_XRAM_IDLE:
-    case TGT_RSP_INIT_IDLE:
+    case TGT_RSP_MULTI_ACK_IDLE:
     case TGT_RSP_CLEANUP_IDLE:
+    {
       p_vci_tgt.rspval  = false;
       p_vci_tgt.rsrcid  = 0;
@@ -7316,4 +7893,30 @@
       p_vci_tgt.reop    = false;
       break;
+    }
+    case TGT_RSP_CONFIG:
+    {
+      p_vci_tgt.rspval  = true;
+      p_vci_tgt.rdata   = 0;
+      p_vci_tgt.rsrcid  = r_config_to_tgt_rsp_srcid.read();
+      p_vci_tgt.rtrdid  = r_config_to_tgt_rsp_trdid.read();
+      p_vci_tgt.rpktid  = r_config_to_tgt_rsp_pktid.read();
+      p_vci_tgt.rerror  = r_config_to_tgt_rsp_error.read();
+      p_vci_tgt.reop    = true;
+
+      break;
+    }
+
+    case TGT_RSP_TGT_CMD:
+    {
+      p_vci_tgt.rspval  = true;
+      p_vci_tgt.rdata   = 0;
+      p_vci_tgt.rsrcid  = r_tgt_cmd_to_tgt_rsp_srcid.read();
+      p_vci_tgt.rtrdid  = r_tgt_cmd_to_tgt_rsp_trdid.read();
+      p_vci_tgt.rpktid  = r_tgt_cmd_to_tgt_rsp_pktid.read();
+      p_vci_tgt.rerror  = r_tgt_cmd_to_tgt_rsp_error.read();
+      p_vci_tgt.reop    = true;
+
+      break;
+    }
 
     case TGT_RSP_READ:
@@ -7346,5 +7949,5 @@
     case TGT_RSP_WRITE:
       p_vci_tgt.rspval   = true;
-      if(((r_write_to_tgt_rsp_pktid.read() & 0x7) == TYPE_SC) && r_write_to_tgt_rsp_sc_fail.read())
+      if(((r_write_to_tgt_rsp_pktid.read() & 0x7) == TYPE_SC) and r_write_to_tgt_rsp_sc_fail.read())
         p_vci_tgt.rdata  = 1;
       else
@@ -7404,5 +8007,5 @@
     }
 
-    case TGT_RSP_INIT:
+    case TGT_RSP_MULTI_ACK:
       p_vci_tgt.rspval   = true;
       p_vci_tgt.rdata    = 0; // Can be a CAS or SC rsp
@@ -7416,19 +8019,71 @@
 
   ////////////////////////////////////////////////////////////////////
-  // Initiator command signals on the p_dspin_out port (CC_SEND FSM)
+  //  p_dspin_out port (CC_SEND FSM)
   ////////////////////////////////////////////////////////////////////
 
   p_dspin_out.write = false;
+  p_dspin_out.eop   = false;
   p_dspin_out.data  = 0;
 
   switch(r_cc_send_fsm.read())
   {
-  
+    ///////////////////////////
+    case CC_SEND_CONFIG_IDLE:
     case CC_SEND_XRAM_RSP_IDLE:
     case CC_SEND_WRITE_IDLE:
     case CC_SEND_CAS_IDLE:
     case CC_SEND_CLEANUP_IDLE:
+    {
         break;
-
+    }
+    ////////////////////////////////
+    case CC_SEND_CONFIG_INVAL_HEADER:
+    {
+        uint8_t multi_inval_type;
+        if(m_config_to_cc_send_inst_fifo.read())
+        {
+          multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_INST;
+        }
+        else
+        {
+          multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_DATA;
+        }
+
+        uint64_t flit = 0;
+        uint64_t dest = m_config_to_cc_send_srcid_fifo.read() <<
+                        (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    dest,
+                                    DspinDhccpParam::MULTI_INVAL_DEST);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    m_cc_global_id,
+                                    DspinDhccpParam::MULTI_INVAL_SRCID);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    r_config_to_cc_send_trdid.read(),
+                                    DspinDhccpParam::MULTI_INVAL_UPDT_INDEX);
+
+        DspinDhccpParam::dspin_set( flit,
+                                    multi_inval_type,
+                                    DspinDhccpParam::FROM_MC_TYPE);
+        p_dspin_out.write = true;
+        p_dspin_out.data  = flit;
+        break;
+    }
+    ////////////////////////////////
+    case CC_SEND_CONFIG_INVAL_NLINE:
+    {
+        uint64_t flit = 0;
+        DspinDhccpParam::dspin_set( flit,
+                                    r_config_to_cc_send_nline.read(),
+                                    DspinDhccpParam::MULTI_INVAL_NLINE);
+        p_dspin_out.eop   = true;
+        p_dspin_out.write = true;
+        p_dspin_out.data  = flit;
+        break;
+    }
+    ////////////////////////
     case CC_SEND_CLEANUP_ACK:
       {
@@ -7438,5 +8093,5 @@
           cleanup_ack_type = DspinDhccpParam::TYPE_CLEANUP_ACK_INST;
         }
-        else 
+        else
         {
           cleanup_ack_type = DspinDhccpParam::TYPE_CLEANUP_ACK_DATA;
@@ -7445,11 +8100,6 @@
         uint64_t flit = 0;
         uint64_t dest =
-          r_cleanup_to_cc_send_srcid.read() << 
-          (DspinDhccpParam::SRCID_WIDTH - vci_param::S);
-
-        DspinDhccpParam::dspin_set(
-            flit,
-            1ULL,
-            DspinDhccpParam::FROM_MC_EOP);
+          r_cleanup_to_cc_send_srcid.read() <<
+          (DspinDhccpParam::SRCID_WIDTH - vci_param_int::S);
 
         DspinDhccpParam::dspin_set(
@@ -7473,12 +8123,14 @@
             DspinDhccpParam::FROM_MC_TYPE);
 
+        p_dspin_out.eop   = true;
         p_dspin_out.write = true;
         p_dspin_out.data  = flit;
 
         break;
-      }
-
+    }
+
+    ///////////////////////////////////
     case CC_SEND_XRAM_RSP_INVAL_HEADER:
-      {
+    {
         if(not m_xram_rsp_to_cc_send_inst_fifo.rok()) break;
 
@@ -7488,5 +8140,5 @@
           multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_INST;
         }
-        else 
+        else
         {
           multi_inval_type = DspinDhccpParam::TYPE_MULTI_INVAL_DATA;
